var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

// src/chakra.tsx
import { createVNode as _createVNode, isVNode as _isVNode, mergeProps as _mergeProps } from "vue";
import { computed as computed2, defineComponent, resolveComponent } from "vue";
import { css, isStyleProp } from "@chakra-ui/styled-system";
import { isFunction, objectFilter, isObject, memoizedGet as get } from "@chakra-ui/utils";
import { cx, css as _css } from "@emotion/css";

// src/system.utils.ts
import "@chakra-ui/utils";
import { keyframes, injectGlobal } from "@emotion/css";
import "vue";
var domElements = ["a", "b", "article", "aside", "blockquote", "button", "caption", "cite", "circle", "code", "dd", "div", "dl", "dt", "fieldset", "figcaption", "figure", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "header", "hr", "iframe", "img", "input", "kbd", "label", "li", "mark", "main", "nav", "ol", "p", "path", "pre", "q", "rect", "s", "svg", "section", "select", "strong", "small", "span", "sub", "sup", "table", "tbody", "td", "textarea", "tfoot", "th", "thead", "tr", "ul"];

// src/composables/use-chakra.ts
import { inject } from "vue";
import { useColorMode } from "@chakra-ui/c-color-mode";
import "@chakra-ui/utils";
var useTheme = /* @__PURE__ */ __name(() => {
  const theme = inject("$chakraTheme");
  return theme;
}, "useTheme");
var useChakra = /* @__PURE__ */ __name(() => {
  const theme = useTheme();
  const {
    colorMode,
    forced
  } = useColorMode();
  return {
    theme,
    colorMode,
    forced
  };
}, "useChakra");

// src/chakra.tsx
import { extractStyleAttrs } from "@chakra-ui/vue-utils";

// src/system.types.ts
import "vue";
import "@chakra-ui/styled-system";

// src/dom.types.ts
import "vue";

// src/system.types.ts
import "vue";

// src/chakra.forms.ts
import { computed, getCurrentInstance } from "vue";
import "@chakra-ui/utils";
var formElements = {
  input: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          ...type === "checkbox" && {
            checked: props.modelValue
          },
          onChange: (event) => {
            if (type === "checkbox") {
              emit("change", !(event == null ? void 0 : event.target).checked, event);
              emit("update:modelValue", !(event == null ? void 0 : event.target).checked, event);
              return;
            }
          },
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  textarea: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onInput: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  },
  select: {
    emits: ["input", "change", "onUpdate:modelValue"],
    props: {
      modelValue: [Boolean, String]
    },
    handleValueChange(props, type) {
      return (emit) => {
        return {
          onChange: (event) => {
            emit("input", (event == null ? void 0 : event.currentTarget).value, event);
            emit("update:modelValue", (event == null ? void 0 : event.currentTarget).value, event);
          }
        };
      };
    }
  }
};

// src/chakra.tsx
import "@emotion/serialize";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var chakraProps = {
  as: [String, Object],
  __css: Object,
  sx: Object,
  css: Object,
  noOfLines: [String, Number, Object, Array],
  baseStyle: Object,
  isTruncated: Boolean,
  layerStyle: String,
  textStyle: String,
  apply: String,
  label: String,
  modelValue: [String, Number, Object, Array],
  __chakraIsRaw: Boolean
};
function ___chakra___(tag, options = {}) {
  const inputHandlers = formElements[typeof tag === "string" ? tag : ""];
  const _props = inputHandlers && inputHandlers.props || {};
  const handleValueChange = inputHandlers && inputHandlers.handleValueChange;
  return defineComponent({
    name: `chakra-factory-${String(tag)}`,
    inheritAttrs: false,
    props: {
      ...chakraProps,
      ..._props
    },
    setup(props, {
      slots,
      emit,
      attrs
    }) {
      const {
        theme,
        colorMode,
        forced
      } = useChakra();
      const layerStyle$ = computed2(() => props.layerStyle || (options == null ? void 0 : options.layerStyle));
      const textStyle$ = computed2(() => props.textStyle || (options == null ? void 0 : options.textStyle));
      const baseStyle$ = computed2(() => props.baseStyle || (options == null ? void 0 : options.baseStyle));
      const noOfLines$ = computed2(() => props.noOfLines || (options == null ? void 0 : options.noOfLines));
      const isTruncated$ = computed2(() => props.isTruncated || (options == null ? void 0 : options.isTruncated));
      const __css$ = computed2(() => props.__css || (options == null ? void 0 : options.__css));
      const css$ = computed2(() => props.css || (options == null ? void 0 : options.css));
      const sx$ = computed2(() => props.sx || (options == null ? void 0 : options.sx));
      const apply$ = computed2(() => props.apply || (options == null ? void 0 : options.apply));
      return () => {
        const {
          class: inheritedClass,
          __label,
          ...rest
        } = attrs;
        const {
          layerStyle,
          baseStyle,
          textStyle,
          noOfLines,
          isTruncated,
          __css,
          css: css2,
          sx,
          apply,
          label,
          ...otherStyles
        } = options;
        const {
          styles,
          attrs: elementAttributes
        } = extractStyleAttrs({
          ...otherStyles,
          ...rest
        });
        const resolvedComponentStyles = resolveStyles({
          __css: __css$.value,
          baseStyle: baseStyle$.value,
          apply: apply$.value,
          layerStyle: layerStyle$.value,
          noOfLines: noOfLines$.value,
          isTruncated: isTruncated$.value,
          textStyle: textStyle$.value,
          sx: sx$.value,
          css: css$.value,
          ...styles,
          theme
        });
        const componentLabel = label || __label;
        const _componentName = componentLabel ? `chakra-${componentLabel}` : "";
        const className = _css(resolvedComponentStyles);
        let componentOrTag = props.as || tag;
        if (!isObject(componentOrTag) && !domElements.includes(componentOrTag)) {
          componentOrTag = resolveComponent(componentOrTag);
        }
        const Tag = componentOrTag || props.as;
        return _createVNode(Tag, _mergeProps({
          "class": cx(inheritedClass, _componentName, className)
        }, elementAttributes, {
          "data-theme": forced ? colorMode.value : void 0
        }, !props.__chakraIsRaw && handleValueChange && handleValueChange(props, attrs.type)(emit)), _isSlot(slots) ? slots : {
          default: () => [slots]
        });
      };
    }
  });
}
__name(___chakra___, "___chakra___");
var chakra = Object.assign(___chakra___, domElements.reduce((acc, curr) => {
  acc[curr] = ___chakra___(curr);
  return acc;
}, {}));
var toCSSObject = /* @__PURE__ */ __name((options) => (props) => {
  const {
    theme,
    css: cssProp,
    __css,
    sx,
    ...rest
  } = props;
  const styleProps = objectFilter(rest, (_, prop) => isStyleProp(prop));
  const finalStyles = resolveStyles(Object.assign(options, {
    theme
  }, styleProps));
  const computedCSS = css(finalStyles)(props.theme);
  return cssProp ? [computedCSS, cssProp] : computedCSS;
}, "toCSSObject");
function styled(component, options) {
  const {
    baseStyle,
    ...styledOptions
  } = options != null ? options : {};
  const styleObject = toCSSObject(options);
  return chakra(component, styledOptions);
}
__name(styled, "styled");
var _chakra = styled;
var resolveStyles = /* @__PURE__ */ __name((resolvers = {}) => {
  const {
    layerStyle,
    baseStyle,
    textStyle,
    noOfLines,
    isTruncated,
    __css,
    css: cssProp,
    sx,
    apply,
    theme,
    ...otherStyles
  } = resolvers;
  const _layerStyle = get(theme, `layerStyles.${layerStyle}`, {});
  const _textStyle = get(theme, `textStyles.${textStyle}`, {});
  let truncateStyle = {};
  if (noOfLines != null) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      display: "-webkit-box",
      WebkitBoxOrient: "vertical",
      WebkitLineClamp: noOfLines
    };
  } else if (isTruncated) {
    truncateStyle = {
      overflow: "hidden",
      textOverflow: "ellipsis",
      whiteSpace: "nowrap"
    };
  }
  const finalStyles = css(Object.assign({}, __css, baseStyle, {
    apply
  }, _layerStyle, _textStyle, truncateStyle, otherStyles, sx))(theme);
  const cssObject = Object.assign(finalStyles, isFunction(cssProp) ? cssProp(theme) : cssProp);
  return cssObject;
}, "resolveStyles");
domElements.forEach((tag) => {
  _chakra[tag] = _chakra(tag);
});

// src/providers.ts
import { createContext } from "@chakra-ui/vue-utils";
import "@chakra-ui/utils";
import "@chakra-ui/styled-system";
import "vue";
var [StylesProvider, useStyles] = createContext({
  name: "StylesContext",
  errorMessage: "useStyles: `styles` is undefined. Seems you forgot to provide `StylesProvider(...)` "
});
var createStylesContext = /* @__PURE__ */ __name((componentName) => createContext({
  name: `${componentName}StylesContext`,
  errorMessage: `useStyles: "styles" is undefined. Seems you forgot to wrap the components in "<${componentName} />" `
}), "createStylesContext");

// src/composables/use-style-config.ts
import { computed as computed3 } from "vue";
import "@chakra-ui/styled-system";
import { filterUndefined, get as get2, mergeWith, runIfFn } from "@chakra-ui/utils";
function useStyleConfig(themeKey, themingProps, options = {}) {
  return computed3(() => {
    var _a, _b, _c, _d, _e, _f, _g;
    const {
      styleConfig: styleConfigProp,
      ...rest
    } = themingProps.value || themingProps;
    const {
      theme,
      colorMode
    } = useChakra();
    const themeStyleConfig = get2(theme, `components.${themeKey}`);
    const styleConfig = styleConfigProp || themeStyleConfig;
    const mergedProps = mergeWith({
      theme,
      colorMode: colorMode.value
    }, (_a = styleConfig == null ? void 0 : styleConfig.defaultProps) != null ? _a : {}, filterUndefined(rest));
    const baseStyles = runIfFn((_b = styleConfig == null ? void 0 : styleConfig.baseStyle) != null ? _b : {}, mergedProps);
    const variants = runIfFn((_d = (_c = styleConfig == null ? void 0 : styleConfig.variants) == null ? void 0 : _c[mergedProps.variant]) != null ? _d : {}, mergedProps);
    const sizes = runIfFn((_f = (_e = styleConfig == null ? void 0 : styleConfig.sizes) == null ? void 0 : _e[mergedProps.size]) != null ? _f : {}, mergedProps);
    const styles = mergeWith({}, baseStyles, sizes, variants);
    if (options.isMultiPart && (styleConfig == null ? void 0 : styleConfig.parts)) {
      (_g = styleConfig == null ? void 0 : styleConfig.parts) == null ? void 0 : _g.forEach((part) => {
        var _a2;
        styles[part] = (_a2 = styles[part]) != null ? _a2 : {};
      });
    }
    return styles;
  });
}
__name(useStyleConfig, "useStyleConfig");
function useMultiStyleConfig(themeKey, themingProps) {
  return useStyleConfig(themeKey, themingProps, {
    isMultiPart: true
  });
}
__name(useMultiStyleConfig, "useMultiStyleConfig");

// src/index.tsx
export * from "@chakra-ui/styled-system";
export {
  StylesProvider,
  ___chakra___,
  _chakra,
  chakra,
  createStylesContext,
  domElements,
  injectGlobal,
  keyframes,
  resolveStyles,
  styled,
  toCSSObject,
  useChakra,
  useMultiStyleConfig,
  useStyleConfig,
  useStyles,
  useTheme
};
